config/routes.rb
require 'sidekiq/web'
require 'sidekiq/cron/web'
require 'sidekiq-status/web'

Rails.application.routes.draw do # rubocop:todo Metrics/BlockLength

  devise_for :users, controllers: {
    registrations: 'users/registrations'
  }

  root 'home#index'
  get '/about', to: 'home#about', as: 'about'
  get '/terms', to: 'home#licence', as: 'terms'
  get '/stats', to: 'home#stats', as: 'stats'
  get '/profile', to: 'profile#index', as: 'profile'

  namespace 'api' do
    namespace 'v1' do
      get '/', to: 'home#index'
      get '/me', to: 'users#me'

      resources :kingdoms, only: %i[index show]
      resources :subkingdoms, only: %i[index show]
      resources :division_orders, only: %i[index show]
      resources :division_classes, only: %i[index show]
      resources :divisions, only: %i[index show]
      resources :families, only: %i[index show] do
        resources :genus, only: %i[index show]
      end
      resources :genus, only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end

      resources :plants, only: %i[index show] do
        resources :species, only: %i[index show]
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :species, only: %i[index show] do
        resources :record_corrections, only: %i[index], path: 'corrections'
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :record_corrections, path: 'corrections', only: %i[index show] do
        post '/:record_type/:record_id', to: 'record_corrections#create', on: :collection
        get :mine, to: 'record_corrections#index', on: :collection, mine: true
      end

      resources :zones, path: 'distributions', only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end
    end

    namespace 'auth' do
      post '/claim', to: 'auth#claim'
    end

    match '*all', controller: 'api', action: 'cors_preflight_check', via: [:options]
  end

  namespace 'explore' do
    get '/', to: 'species#index'
    get '/data', to: 'data#index'
    resources :species, only: %i[index show] do
      resources :record_corrections, only: %i[index], path: 'corrections'
    end
    resources :genus, only: %i[index show] do
    end
    resources :record_corrections, path: 'corrections', only: %i[index show] do

    end
  end

  namespace 'management' do
    authenticate :user, ->(user) { user.admin? } do
      mount PgHero::Engine, at: 'pghero'
      mount Sidekiq::Web => '/sidekiq'
    end

    get '/', to: 'plants#index'

    resources :users
    resources :user_queries do
      get :stats, on: :collection
    end
    resources :subkingdoms
    resources :species_proposals
    resources :species_images do
      get :chaos, on: :collection
    end
    resources :record_corrections do
      patch :accept, on: :member
      patch :reject, on: :member
    end

    resources :species do
      patch :refresh, on: :member
    end

    resources :sessions
    resources :plants
    resources :major_groups
    resources :kingdoms
    resources :genuses
    resources :foreign_sources_plants
    resources :foreign_sources
    resources :families
    resources :divisions
    resources :division_orders
    resources :division_classes
  end

end

app/controllers/management/division_classes_controller.rb
class Management::DivisionClassesController < Management::ManagementController
  before_action :set_division_class, only: %i[show edit update destroy]

  # GET /division_classes
  # GET /division_classes.json
  def index
    @division_classes = DivisionClass.all.page params[:page]
  end

  # GET /division_classes/1
  # GET /division_classes/1.json
  def show; end

  # GET /division_classes/new
  def new
    @division_class = DivisionClass.new
  end

  # GET /division_classes/1/edit
  def edit; end

  # POST /division_classes
  # POST /division_classes.json
  def create
    @division_class = DivisionClass.new(division_class_params)

    respond_to do |format|
      if @division_class.save
        format.html { redirect_to @division_class, notice: 'Division class was successfully created.' }
        format.json { render :show, status: :created, location: @division_class }
      else
        format.html { render :new }
        format.json { render json: @division_class.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /division_classes/1
  # PATCH/PUT /division_classes/1.json
  def update
    respond_to do |format|
      if @division_class.update(division_class_params)
        format.html { redirect_to @division_class, notice: 'Division class was successfully updated.' }
        format.json { render :show, status: :ok, location: @division_class }
      else
        format.html { render :edit }
        format.json { render json: @division_class.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /division_classes/1
  # DELETE /division_classes/1.json
  def destroy
    @division_class.destroy
    respond_to do |format|
      format.html { redirect_to division_classes_url, notice: 'Division class was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_division_class
    @division_class = DivisionClass.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def division_class_params
    params.require(:division_class).permit(:name, :slug, :division_id, :inserted_at)
  end
end

app/controllers/management/division_orders_controller.rb
class Management::DivisionOrdersController < Management::ManagementController
  before_action :set_division_order, only: %i[show edit update destroy]

  # GET /division_orders
  # GET /division_orders.json
  def index
    @division_orders = DivisionOrder.all.page params[:page]
  end

  # GET /division_orders/1
  # GET /division_orders/1.json
  def show; end

  # GET /division_orders/new
  def new
    @division_order = DivisionOrder.new
  end

  # GET /division_orders/1/edit
  def edit; end

  # POST /division_orders
  # POST /division_orders.json
  def create
    @division_order = DivisionOrder.new(division_order_params)

    respond_to do |format|
      if @division_order.save
        format.html { redirect_to @division_order, notice: 'Division order was successfully created.' }
        format.json { render :show, status: :created, location: @division_order }
      else
        format.html { render :new }
        format.json { render json: @division_order.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /division_orders/1
  # PATCH/PUT /division_orders/1.json
  def update
    respond_to do |format|
      if @division_order.update(division_order_params)
        format.html { redirect_to @division_order, notice: 'Division order was successfully updated.' }
        format.json { render :show, status: :ok, location: @division_order }
      else
        format.html { render :edit }
        format.json { render json: @division_order.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /division_orders/1
  # DELETE /division_orders/1.json
  def destroy
    @division_order.destroy
    respond_to do |format|
      format.html { redirect_to division_orders_url, notice: 'Division order was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_division_order
    @division_order = DivisionOrder.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def division_order_params
    params.require(:division_order).permit(:name, :slug, :division_class_id, :inserted_at)
  end
end

app/controllers/management/divisions_controller.rb
class Management::DivisionsController < Management::ManagementController
  before_action :set_division, only: %i[show edit update destroy]

  # GET /divisions
  # GET /divisions.json
  def index
    @divisions = Division.all.page params[:page]
  end

  # GET /divisions/1
  # GET /divisions/1.json
  def show; end

  # GET /divisions/new
  def new
    @division = Division.new
  end

  # GET /divisions/1/edit
  def edit; end

  # POST /divisions
  # POST /divisions.json
  def create
    @division = Division.new(division_params)

    respond_to do |format|
      if @division.save
        format.html { redirect_to @division, notice: 'Division was successfully created.' }
        format.json { render :show, status: :created, location: @division }
      else
        format.html { render :new }
        format.json { render json: @division.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /divisions/1
  # PATCH/PUT /divisions/1.json
  def update
    respond_to do |format|
      if @division.update(division_params)
        format.html { redirect_to @division, notice: 'Division was successfully updated.' }
        format.json { render :show, status: :ok, location: @division }
      else
        format.html { render :edit }
        format.json { render json: @division.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /divisions/1
  # DELETE /divisions/1.json
  def destroy
    @division.destroy
    respond_to do |format|
      format.html { redirect_to divisions_url, notice: 'Division was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_division
    @division = Division.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def division_params
    params.require(:division).permit(:name, :slug, :subkingdom_id, :inserted_at)
  end
end

app/controllers/management/families_controller.rb
class Management::FamiliesController < Management::ManagementController
  before_action :set_family, only: %i[show edit update destroy]

  # GET /families
  # GET /families.json
  def index
    @families = Family.all.page params[:page]
  end

  # GET /families/1
  # GET /families/1.json
  def show; end

  # GET /families/new
  def new
    @family = Family.new
  end

  # GET /families/1/edit
  def edit; end

  # POST /families
  # POST /families.json
  def create
    @family = Family.new(family_params)

    respond_to do |format|
      if @family.save
        format.html { redirect_to @family, notice: 'Family was successfully created.' }
        format.json { render :show, status: :created, location: @family }
      else
        format.html { render :new }
        format.json { render json: @family.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /families/1
  # PATCH/PUT /families/1.json
  def update
    respond_to do |format|
      if @family.update(family_params)
        format.html { redirect_to @family, notice: 'Family was successfully updated.' }
        format.json { render :show, status: :ok, location: @family }
      else
        format.html { render :edit }
        format.json { render json: @family.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /families/1
  # DELETE /families/1.json
  def destroy
    @family.destroy
    respond_to do |format|
      format.html { redirect_to families_url, notice: 'Family was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_family
    @family = Family.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def family_params
    params.require(:family).permit(:name, :slug, :common_name, :division_order_id, :major_group_id, :inserted_at)
  end
end

app/controllers/management/foreign_sources_controller.rb
class Management::ForeignSourcesController < Management::ManagementController
  before_action :set_foreign_source, only: %i[show edit update destroy]

  # GET /foreign_sources
  # GET /foreign_sources.json
  def index
    @foreign_sources = ForeignSource.all
    @pagy, @foreign_sources = pagy(@foreign_sources)
  end

  # GET /foreign_sources/1
  # GET /foreign_sources/1.json
  def show; end

  # GET /foreign_sources/new
  def new
    @foreign_source = ForeignSource.new
  end

  # GET /foreign_sources/1/edit
  def edit; end

  # POST /foreign_sources
  # POST /foreign_sources.json
  def create
    @foreign_source = ForeignSource.new(foreign_source_params)

    respond_to do |format|
      if @foreign_source.save
        format.html { redirect_to @foreign_source, notice: 'Foreign source was successfully created.' }
        format.json { render :show, status: :created, location: @foreign_source }
      else
        format.html { render :new }
        format.json { render json: @foreign_source.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /foreign_sources/1
  # PATCH/PUT /foreign_sources/1.json
  def update
    respond_to do |format|
      if @foreign_source.update(foreign_source_params)
        format.html { redirect_to @foreign_source, notice: 'Foreign source was successfully updated.' }
        format.json { render :show, status: :ok, location: @foreign_source }
      else
        format.html { render :edit }
        format.json { render json: @foreign_source.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /foreign_sources/1
  # DELETE /foreign_sources/1.json
  def destroy
    @foreign_source.destroy
    respond_to do |format|
      format.html { redirect_to foreign_sources_url, notice: 'Foreign source was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_foreign_source
    @foreign_source = ForeignSource.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def foreign_source_params
    params.require(:foreign_source).permit(:name, :slug, :url, :inserted_at)
  end
end

app/controllers/management/foreign_sources_plants_controller.rb
class Management::ForeignSourcesPlantsController < Management::ManagementController
  before_action :set_foreign_sources_plant, only: %i[show edit update destroy]

  # GET /foreign_sources_plants
  # GET /foreign_sources_plants.json
  def index
    @foreign_sources_plants = ForeignSourcesPlant.all
    @pagy, @foreign_sources_plants = pagy(@foreign_sources_plants)
  end

  # GET /foreign_sources_plants/1
  # GET /foreign_sources_plants/1.json
  def show; end

  # GET /foreign_sources_plants/new
  def new
    @foreign_sources_plant = ForeignSourcesPlant.new
  end

  # GET /foreign_sources_plants/1/edit
  def edit; end

  # POST /foreign_sources_plants
  # POST /foreign_sources_plants.json
  def create
    @foreign_sources_plant = ForeignSourcesPlant.new(foreign_sources_plant_params)

    respond_to do |format|
      if @foreign_sources_plant.save
        format.html { redirect_to @foreign_sources_plant, notice: 'Foreign sources plant was successfully created.' }
        format.json { render :show, status: :created, location: @foreign_sources_plant }
      else
        format.html { render :new }
        format.json { render json: @foreign_sources_plant.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /foreign_sources_plants/1
  # PATCH/PUT /foreign_sources_plants/1.json
  def update
    respond_to do |format|
      if @foreign_sources_plant.update(foreign_sources_plant_params)
        format.html { redirect_to @foreign_sources_plant, notice: 'Foreign sources plant was successfully updated.' }
        format.json { render :show, status: :ok, location: @foreign_sources_plant }
      else
        format.html { render :edit }
        format.json { render json: @foreign_sources_plant.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /foreign_sources_plants/1
  # DELETE /foreign_sources_plants/1.json
  def destroy
    @foreign_sources_plant.destroy
    respond_to do |format|
      format.html { redirect_to foreign_sources_plants_url, notice: 'Foreign sources plant was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_foreign_sources_plant
    @foreign_sources_plant = ForeignSourcesPlant.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def foreign_sources_plant_params
    params.require(:foreign_sources_plant).permit(:last_update, :species_id, :foreign_source_id, :fid, :inserted_at)
  end
end

app/views/management/species_proposals/edit.html.erb
<h1>Editing Species Proposal</h1>

<%= render 'form', species_proposal: @species_proposal %>

<%= link_to 'Show', @species_proposal %> |
<%= link_to 'Back', species_proposals_path %>

app/views/management/species_proposals/index.html.erb
<p id="notice" class="notification is-info"><%= notice %></p>

<h1>Species Proposals</h1>

<table>
  <thead>
    <tr>
      <th>Year</th>
      <th>Bibliography</th>
      <th>Author</th>
      <th>Scientific name</th>
      <th>Status</th>
      <th>Fruit conspicuous</th>
      <th>Coppice potential</th>
      <th>Fruit seed period end</th>
      <th>Resprout ability</th>
      <th>Propogated by sprigs</th>
      <th>Propogated by cuttings</th>
      <th>Fodder product</th>
      <th>Precipitation minimum</th>
      <th>Toxicity</th>
      <th>Foliage texture</th>
      <th>Fruit seed abundance</th>
      <th>Fire resistance</th>
      <th>Height at base age max ft</th>
      <th>Fall conspicuous</th>
      <th>Fire tolerance</th>
      <th>Ph minimum</th>
      <th>Propogated by container</th>
      <th>Flower conspicuous</th>
      <th>Native status</th>
      <th>Fuelwood product</th>
      <th>Frost free days minimum</th>
      <th>Growth habit</th>
      <th>Protein potential</th>
      <th>Planting density per acre maximum</th>
      <th>Root depth minimum inches</th>
      <th>Adapted to medium textured soils</th>
      <th>Growth form</th>
      <th>After harvest regrowth rate</th>
      <th>Drought tolerance</th>
      <th>Salinity tolerance</th>
      <th>Fertility requirement</th>
      <th>Foliage color</th>
      <th>Nitrogen fixation</th>
      <th>Commercial availability</th>
      <th>Anaerobic tolerance</th>
      <th>Lifespan</th>
      <th>Veneer product</th>
      <th>Bloat</th>
      <th>Precipitation maximum</th>
      <th>Planting density per acre minimum</th>
      <th>Foliage porosity winter</th>
      <th>Height mature ft</th>
      <th>Ph maximum</th>
      <th>Christmas tree product</th>
      <th>Shape and orientation</th>
      <th>Shade tolerance</th>
      <th>Usda synonym</th>
      <th>Pulpwood product</th>
      <th>Small grain</th>
      <th>Low growing grass</th>
      <th>Berry nut seed product</th>
      <th>Vegetative spread rate</th>
      <th>Propogated by bare root</th>
      <th>Propogated by sod</th>
      <th>Fruit seed period begin</th>
      <th>Palatable browse animal</th>
      <th>Foliage porosity summer</th>
      <th>Seeds per pound</th>
      <th>Adapted to fine textured soils</th>
      <th>Hedge tolerance</th>
      <th>Post product</th>
      <th>Growth rate</th>
      <th>Propogated by seed</th>
      <th>Fruit color</th>
      <th>Nursery stock product</th>
      <th>Seedling vigor</th>
      <th>Cold stratification required</th>
      <th>Palatable graze animal</th>
      <th>Bloom period</th>
      <th>Fruit seed persistence</th>
      <th>Propogated by bulbs</th>
      <th>Active growth period</th>
      <th>C n ratio</th>
      <th>Duration</th>
      <th>Flower color</th>
      <th>Leaf retention</th>
      <th>Known allelopath</th>
      <th>Palatable human</th>
      <th>Propogated by tubers</th>
      <th>Moisture use</th>
      <th>Lumber product</th>
      <th>Adapted to coarse textured soils</th>
      <th>Propogated by corms</th>
      <th>Temperature minimum deg f</th>
      <th>Naval store product</th>
      <th>Seed spread rate</th>
      <th>Caco 3 tolerance</th>
      <th>Species type</th>
      <th>Usda name</th>
      <th>Family common name</th>
      <th>Common name</th>
      <th>Complete data</th>
      <th>Genus</th>
      <th>User</th>
      <th>Inserted at</th>
      <th>Change type</th>
      <th>Change status</th>
      <th>Synonym of</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @species_proposals.each do |species_proposal| %>
      <tr>
        <td><%= species_proposal.year %></td>
        <td><%= species_proposal.bibliography %></td>
        <td><%= species_proposal.author %></td>
        <td><%= species_proposal.scientific_name %></td>
        <td><%= species_proposal.status %></td>
        <td><%= species_proposal.fruit_conspicuous %></td>
        <td><%= species_proposal.coppice_potential %></td>
        <td><%= species_proposal.fruit_seed_period_end %></td>
        <td><%= species_proposal.resprout_ability %></td>
        <td><%= species_proposal.propogated_by_sprigs %></td>
        <td><%= species_proposal.propogated_by_cuttings %></td>
        <td><%= species_proposal.fodder_product %></td>
        <td><%= species_proposal.precipitation_minimum %></td>
        <td><%= species_proposal.toxicity %></td>
        <td><%= species_proposal.foliage_texture %></td>
        <td><%= species_proposal.fruit_seed_abundance %></td>
        <td><%= species_proposal.fire_resistance %></td>
        <td><%= species_proposal.height_at_base_age_max_ft %></td>
        <td><%= species_proposal.fall_conspicuous %></td>
        <td><%= species_proposal.fire_tolerance %></td>
        <td><%= species_proposal.ph_minimum %></td>
        <td><%= species_proposal.propogated_by_container %></td>
        <td><%= species_proposal.flower_conspicuous %></td>
        <td><%= species_proposal.native_status %></td>
        <td><%= species_proposal.fuelwood_product %></td>
        <td><%= species_proposal.frost_free_days_minimum %></td>
        <td><%= species_proposal.growth_habit %></td>
        <td><%= species_proposal.protein_potential %></td>
        <td><%= species_proposal.planting_density_per_acre_maximum %></td>
        <td><%= species_proposal.root_depth_minimum_inches %></td>
        <td><%= species_proposal.adapted_to_medium_textured_soils %></td>
        <td><%= species_proposal.growth_form %></td>
        <td><%= species_proposal.after_harvest_regrowth_rate %></td>
        <td><%= species_proposal.drought_tolerance %></td>
        <td><%= species_proposal.salinity_tolerance %></td>
        <td><%= species_proposal.fertility_requirement %></td>
        <td><%= species_proposal.foliage_color %></td>
        <td><%= species_proposal.nitrogen_fixation %></td>
        <td><%= species_proposal.commercial_availability %></td>
        <td><%= species_proposal.anaerobic_tolerance %></td>
        <td><%= species_proposal.lifespan %></td>
        <td><%= species_proposal.veneer_product %></td>
        <td><%= species_proposal.bloat %></td>
        <td><%= species_proposal.precipitation_maximum %></td>
        <td><%= species_proposal.planting_density_per_acre_minimum %></td>
        <td><%= species_proposal.foliage_porosity_winter %></td>
        <td><%= species_proposal.height_mature_ft %></td>
        <td><%= species_proposal.ph_maximum %></td>
        <td><%= species_proposal.christmas_tree_product %></td>
        <td><%= species_proposal.shape_and_orientation %></td>
        <td><%= species_proposal.shade_tolerance %></td>
        <td><%= species_proposal.usda_synonym %></td>
        <td><%= species_proposal.pulpwood_product %></td>
        <td><%= species_proposal.small_grain %></td>
        <td><%= species_proposal.low_growing_grass %></td>
        <td><%= species_proposal.berry_nut_seed_product %></td>
        <td><%= species_proposal.vegetative_spread_rate %></td>
        <td><%= species_proposal.propogated_by_bare_root %></td>
        <td><%= species_proposal.propogated_by_sod %></td>
        <td><%= species_proposal.fruit_seed_period_begin %></td>
        <td><%= species_proposal.palatable_browse_animal %></td>
        <td><%= species_proposal.foliage_porosity_summer %></td>
        <td><%= species_proposal.seeds_per_pound %></td>
        <td><%= species_proposal.adapted_to_fine_textured_soils %></td>
        <td><%= species_proposal.hedge_tolerance %></td>
        <td><%= species_proposal.post_product %></td>
        <td><%= species_proposal.growth_rate %></td>
        <td><%= species_proposal.propogated_by_seed %></td>
        <td><%= species_proposal.fruit_color %></td>
        <td><%= species_proposal.nursery_stock_product %></td>
        <td><%= species_proposal.seedling_vigor %></td>
        <td><%= species_proposal.cold_stratification_required %></td>
        <td><%= species_proposal.palatable_graze_animal %></td>
        <td><%= species_proposal.bloom_period %></td>
        <td><%= species_proposal.fruit_seed_persistence %></td>
        <td><%= species_proposal.propogated_by_bulbs %></td>
        <td><%= species_proposal.active_growth_period %></td>
        <td><%= species_proposal.c_n_ratio %></td>
        <td><%= species_proposal.duration %></td>
        <td><%= species_proposal.flower_color %></td>
        <td><%= species_proposal.leaf_retention %></td>
        <td><%= species_proposal.known_allelopath %></td>
        <td><%= species_proposal.palatable_human %></td>
        <td><%= species_proposal.propogated_by_tubers %></td>
        <td><%= species_proposal.moisture_use %></td>
        <td><%= species_proposal.lumber_product %></td>
        <td><%= species_proposal.adapted_to_coarse_textured_soils %></td>
        <td><%= species_proposal.propogated_by_corms %></td>
        <td><%= species_proposal.temperature_minimum_deg_f %></td>
        <td><%= species_proposal.naval_store_product %></td>
        <td><%= species_proposal.seed_spread_rate %></td>
        <td><%= species_proposal.caco_3_tolerance %></td>
        <td><%= species_proposal.species_type %></td>
        <td><%= species_proposal.usda_name %></td>
        <td><%= species_proposal.family_common_name %></td>
        <td><%= species_proposal.common_name %></td>
        <td><%= species_proposal.complete_data %></td>
        <td><%= species_proposal.genus %></td>
        <td><%= species_proposal.user %></td>
        <td><%= species_proposal.inserted_at %></td>
        <td><%= species_proposal.change_type %></td>
        <td><%= species_proposal.change_status %></td>
        <td><%= species_proposal.synonym_of %></td>
        <td><%= link_to 'Show', species_proposal %></td>
        <td><%= link_to 'Edit', edit_species_proposal_path(species_proposal) %></td>
        <td><%= link_to 'Destroy', species_proposal, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>
<%= paginate @species_proposals %>

<br>

<%= link_to 'New Species Proposal', new_species_proposal_path %>

app/views/management/species_proposals/new.html.erb
<h1>New Species Proposal</h1>

<%= render 'form', species_proposal: @species_proposal %>

<%= link_to 'Back', species_proposals_path %>